Package oracle.dbtools.plugin.api.conf

## Class ConfigurationSetting.Builder

- java.lang.Object
- - oracle.dbtools.plugin.api.conf.ConfigurationSetting.Builder

- Enclosing class:
    ConfigurationSetting

      public static class ConfigurationSetting.Builder
      extends java.lang.Object

  Builds `ConfigurationSetting` instances
  Author:
    cdivilly

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Builder()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ConfigurationSetting` | `build()` | Build the `ConfigurationSetting` instance
    `ConfigurationSetting.Builder` | `defaultValue​(java.lang.Object defaultValue)` | Specify the default value of this setting, if no explicit value is found in the `Configuration`.
    `ConfigurationSetting.Builder` | `description​(Translatable description)` |
    `ConfigurationSetting.Builder` | `global​(boolean global)` | Specify whether this is a global setting or not
    `ConfigurationSetting.Builder` | `override​(boolean override)` | Specify whether this setting can be overridden at runtime.
    `ConfigurationSetting.Builder` | `secure​(boolean secure)` | Specify whether this setting contains sensitive data such as passwords.
    `ConfigurationSetting.Builder` | `status​(ConfigurationStatus status)` | Specify the status of the configuration setting
    `ConfigurationSetting.Builder` | `type​(java.lang.Class<?> type)` | Specify the data type of the setting

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Builder

          public Builder()

  - ### Method Detail

    - #### build

          public ConfigurationSetting build()

      Build the `ConfigurationSetting` instance
      Returns:
        `ConfigurationSetting` instance

    - #### defaultValue

          public ConfigurationSetting.Builder defaultValue​(java.lang.Object defaultValue)

      Specify the default value of this setting, if no explicit value is found in the `Configuration`.
      Parameters:
        `defaultValue` - The default value to use for the setting, if no explicit value is provided in the configuration
      Returns:
        self

    - #### description

          public ConfigurationSetting.Builder description​(Translatable description)

    - #### global

          public ConfigurationSetting.Builder global​(boolean global)

      Specify whether this is a global setting or not
      Parameters:
        `global` - true if the setting is global, false otherwise
      Returns:
        self

    - #### override

          public ConfigurationSetting.Builder override​(boolean override)

      Specify whether this setting can be overridden at runtime.
      Parameters:
        `override` - true if this setting can be overridden, false otherwise
      Returns:
        self

    - #### secure

          public ConfigurationSetting.Builder secure​(boolean secure)

      Specify whether this setting contains sensitive data such as passwords.
      Parameters:
        `secure` - true if this setting is sensitive, false otherwise
      Returns:
        self

    - #### status

          public ConfigurationSetting.Builder status​(ConfigurationStatus status)

      Specify the status of the configuration setting
      Parameters:
        `status` - The status of the configuration setting
      Returns:

    - #### type

          public ConfigurationSetting.Builder type​(java.lang.Class<?> type)

      Specify the data type of the setting
      Parameters:
        `type` - The data type
      Returns:
        self